diff --git a/Makefile.am b/Makefile.am
index b1aacdf..cd597d5 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,10 +1,10 @@
 RPM		= rpmbuild
 RPMFLAGS	= -ta
 
-SUBDIRS    = include utils lib unix $(GLIB_DIR) $(TCL_DIR) libedit cmdlang \
+SUBDIRS    = include utils lib unix $(GLIB_DIR) $(TCL_DIR) cmdlang \
 	     ui lanserv sample doc man $(SWIG_DIR)
 
-DIST_SUBDIRS = include utils lib unix glib tcl libedit cmdlang \
+DIST_SUBDIRS = include utils lib unix glib tcl cmdlang \
 	     ui lanserv sample doc man swig
 
 EXTRA_DIST = FAQ TODO README.Force README.MotorolaMXP OpenIPMI.spec.in \
@@ -29,10 +29,10 @@ uninstall-local:
 rpm: dist
 	$(RPM) $(RPMFLAGS) $(distdir).tar.gz < /dev/null
 
-PYPATH=$(top_builddir)/swig/python:$(top_builddir)/swig/python/.libs:$(srcdir)/openipmigui
+PYPATH=$(top_builddir)/swig/python:$(top_builddir)/swig/python/.libs
 
 rungui:
-	LD_LIBRARY_PATH=$(top_builddir)/glib/.libs LD_PRELOAD=$(OPENIPMI_SWIG_SO):$(top_builddir)/swig/python/.libs/_OpenIPMI.so PYTHONPATH=$(PYPATH) $(pythonprog) $(top_srcdir)/swig/python/openipmigui.py
+	LD_LIBRARY_PATH=$(top_builddir)/glib/.libs LD_PRELOAD=$(OPENIPMI_SWIG_SO):$(top_builddir)/swig/python/.libs/_OpenIPMI.so PYTHONPATH=$(PYPATH) $(PYTHON) $(top_srcdir)/swig/python/openipmigui.py
 
 DISTCLEANFILES=OpenIPMI.spec OpenIPMIcmdlang.pc OpenIPMI.pc OpenIPMItcl.pc \
 	OpenIPMIglib12.pc OpenIPMIposix.pc OpenIPMIui.pc OpenIPMIglib.pc \
diff --git a/cmdlang/Makefile.am b/cmdlang/Makefile.am
index 264ee12..0ca3827 100644
--- a/cmdlang/Makefile.am
+++ b/cmdlang/Makefile.am
@@ -4,7 +4,7 @@ LD_VERSION = 0:5:0
 
 AM_CFLAGS = -Wall -Wsign-compare -I$(top_builddir)/include \
 	-I$(top_srcdir)/include \
-	-I$(top_srcdir)/libedit -DIPMI_CHECK_LOCKS $(GLIB_CFLAGS) \
+	-DIPMI_CHECK_LOCKS $(GLIB_CFLAGS) \
 	$(TCL_CFLAGS)
 
 lib_LTLIBRARIES = libOpenIPMIcmdlang.la
@@ -25,7 +25,7 @@ openipmish_LDADD =  libOpenIPMIcmdlang.la \
 		$(top_builddir)/utils/libOpenIPMIutils.la \
 		$(top_builddir)/lib/libOpenIPMI.la \
 		$(top_builddir)/unix/libOpenIPMIposix.la \
-		$(top_builddir)/libedit/libedit.a \
+		-lreadline \
 		$(TERM_LIBS) \
 		$(SNMPLIBS) $(GLIB_LIB) $(GLIB_LIBS) \
 		$(TCL_LIB) $(TCL_LIBS) \
diff --git a/cmdlang/ipmish.c b/cmdlang/ipmish.c
index 906cf19..139da67 100644
--- a/cmdlang/ipmish.c
+++ b/cmdlang/ipmish.c
@@ -50,7 +50,7 @@
 #include <OpenIPMI/ipmi_tcl.h>
 #include <OpenIPMI/ipmi_cmdlang.h>
 #include <OpenIPMI/ipmi_debug.h>
-#include <editline/readline.h>
+#include <readline/readline.h>
 
 #ifdef HAVE_GLIB
 #include <glib.h>
@@ -1049,6 +1049,8 @@ main(int argc, char *argv[])
 	}
     }
 
+    rl_initialize();
+
     if (use_debug_os) {
 	os_hnd = &ipmi_debug_os_handlers;
 	rv = sel_alloc_selector_nothread(&debug_sel);
diff --git a/configure.ac b/configure.ac
index f8bb95f..173226c 100644
--- a/configure.ac
+++ b/configure.ac
@@ -187,14 +187,18 @@ AC_ARG_WITH(perlusepthreads,
    fi,
 )
 
+pythonprog=
 trypython=yes
 AC_ARG_WITH(python,
 [  --with-python[[=yes|no|PATH]]     Look for python, with the optional path.],
-    if test "x$withval" = "xyes"; then
+    if test "x$withval" = "x"; then
+      trypython=yes
+    elif test "x$withval" = "xyes"; then
       trypython=yes
     elif test "x$withval" = "xno"; then
       trypython=no
-    elif test -d "$withval"; then
+    else
+      pythonprog="$withval"
       trypython=yes
     fi,
 )
@@ -340,33 +344,22 @@ if test "x$haveglib" = "xyes"; then
    GLIB_SO='$(top_builddir)/glib/.libs/libOpenIPMIglib.so'
    GLIB_PKGCONF=OpenIPMIglib.pc
    GLIB_TARGET=libOpenIPMIglib.la
+   GLIB_DIR=glib
 else
    GLIB_LIB=
    GLIB_SO=
    GLIB_PKGCONF=
    GLIB_TARGET=
+   GLIB_DIR=
 fi
 AC_SUBST(GLIB_VERSION)
 AC_SUBST(GLIB_CFLAGS)
 AC_SUBST(GLIB_LIBS)
-
 AC_SUBST(GLIB_LIB)
 AC_SUBST(GLIB_SO)
 AC_SUBST(GLIB_PKGCONF)
 AC_SUBST(GLIB_TARGET)
-
-if test "x$haveglib" = "xyes"; then
-   GLIB_DIR=glib
-   GLIB_SINGLE_LIB=$GLIB_LIB
-   GLIB_SINGLE_SO=$GLIB_SO
-else
-   GLIB_DIR=
-   GLIB_SINGLE_LIB=
-   GLIB_SINGLE_SO=
-fi
 AC_SUBST(GLIB_DIR)
-AC_SUBST(GLIB_SINGLE_LIB)
-AC_SUBST(GLIB_SINGLE_SO)
 
 # Handle TCL support
 TCL_LIBS=
@@ -523,87 +516,65 @@ AC_SUBST(PERL_POSIX_LIB)
 AC_SUBST(PERL_POSIX_SO)
 
 # Handle PYTHON support
-if test "x$pythoncflags" = "x" -o "x$pythoninstalldir" = "x"; then
-   pythonprog=
-   if test "x$trypython" != "xno"; then
-      AC_PATH_PROG(pythonprog, python)
-   fi
+PYTHON_DIR=
+PYTHON_INSTALL_DIR=
+PYTHON_INSTALL_LIB_DIR=
+PYTHON_SWIG_FLAGS=
+if test "x$trypython" = "xyes"; then
    if test "x$pythonprog" != "x"; then
-      # Now find a proper installation location.
-      if test "x$pythoninstalldir" = "x"; then
-	 pythoninstalldir=`$pythonprog -c 'import distutils.sysconfig; print(distutils.sysconfig.get_python_lib());'`
-	 if test "x$pythoninstalldir" = "x" -o ! -d "$pythoninstalldir"; then
-	    pythoninstalldir=
-	 fi
-      fi
+      PYTHON="$pythonprog"
    fi
-
-   if test "x$pythoncflags" = "x"; then
-      pythoninc=`$pythonprog -c 'import distutils.sysconfig; print(distutils.sysconfig.get_python_inc());'`
-      if test "x$pythoninc" != "x"; then
-         pythoncflags="-I$pythoninc"
-      else
-         pythoncflags=""
-      fi
-   else
-      PYTHON_CFLAGS="$pythoncflags"
+   if test "x$pythoncflags" != "x"; then
+      PYTHON_CPPFLAGS="$pythoncflags"
    fi
-
-   if test "x$pythoninstalldir" != "x"; then
-      if test "x$pythoninstalllibdir" = "x"; then
-	 pythoninstalllibdir=$pythoninstalldir
-      fi
-      AC_DEFINE([HAVE_PYTHON], [], [Have Python installed])
-      PYTHON_DIR=python
-      PYTHON_CFLAGS="$pythoncflags"
-      PYTHON_INSTALL_DIR="$pythoninstalldir"
-      PYTHON_INSTALL_LIB_DIR="$pythoninstalllibdir"
+   AX_PYTHON_DEVEL
+fi
+if test "x$PYTHON" != "x"; then
+   AX_PROG_PYTHON_VERSION([3.0.0], [PYTHON_SWIG_FLAGS=-py3], [])
+   AC_DEFINE([HAVE_PYTHON], [], [Have Python installed])
+   PYTHON_DIR=python
+   if test "x$pythoninstalldir" = "x"; then
+      PYTHON_INSTALL_DIR="$PYTHON_SITE_PKG"
    else
-      PYTHON_DIR=
-      PYTHON_CFLAGS=
-      PYTHON_INSTALL_DIR=
-      PYTHON_INSTALL_LIB_DIR=
+      PYTHON_INSTALL_DIR="$pythoninstalldir"
    fi
-else
    if test "x$pythoninstalllibdir" = "x"; then
-      pythoninstalllibdir=$pythoninstalldir
+      PYTHON_INSTALL_LIB_DIR="$PYTHON_INSTALL_DIR"
+   else
+      PYTHON_INSTALL_LIB_DIR="$pythoninstalllibdir"
    fi
-   AC_DEFINE([HAVE_PYTHON], [], [Have Python installed])
-   PYTHON_DIR=python
-   PYTHON_CFLAGS="$pythoncflags"
-   PYTHON_INSTALL_DIR="$pythoninstalldir"
-   PYTHON_INSTALL_LIB_DIR="$pythoninstalllibdir"
-fi
-if test "x$pythonprog" != "x"; then
+
    if test "x$pythonusepthreads" = "x"; then
       cat - <<_ACEOF >conftest.py
 try:
-  import thread
+  import threading
   print('yes')
 except:
   print('no')
 _ACEOF
-      pythonusepthreads=`python conftest.py`
+      pythonusepthreads=`$PYTHON conftest.py`
       rm -f conftest.py
    fi
    echo "checking for python threads... $pythonusepthreads"
+
+   if test "x$pythonusepthreads" = "xyes"; then
+      PYTHON_HAS_POSIX_THREADS=1
+      PYTHON_POSIX_LIB='$(top_builddir)/unix/libOpenIPMIpthread.la'
+      PYTHON_POSIX_SO='$(top_builddir)/unix/.libs/libOpenIPMIpthread.so'
+   else
+      PYTHON_HAS_POSIX_THREADS=0
+      PYTHON_POSIX_LIB='$(top_builddir)/unix/libOpenIPMIposix.la'
+      PYTHON_POSIX_SO='$(top_builddir)/unix/.libs/libOpenIPMIposix.so'
+   fi
 fi
-if test "x$pythonusepthreads" = "xyes"; then
-   PYTHON_HAS_POSIX_THREADS=1
-   PYTHON_POSIX_LIB='$(top_builddir)/unix/libOpenIPMIpthread.la'
-   PYTHON_POSIX_SO='$(top_builddir)/unix/.libs/libOpenIPMIpthread.so'
-else
-   PYTHON_HAS_POSIX_THREADS=0
-   PYTHON_POSIX_LIB='$(top_builddir)/unix/libOpenIPMIposix.la'
-   PYTHON_POSIX_SO='$(top_builddir)/unix/.libs/libOpenIPMIposix.so'
-fi
+
 AC_SUBST(PYTHON_DIR)
-AC_SUBST(PYTHON_CFLAGS)
 AC_SUBST(PYTHON_INSTALL_DIR)
 AC_SUBST(PYTHON_INSTALL_LIB_DIR)
 AC_SUBST(PYTHON_HAS_POSIX_THREADS)
 AC_SUBST(PYTHON_POSIX_LIB)
 AC_SUBST(PYTHON_POSIX_SO)
+AC_SUBST(PYTHON_SWIG_FLAGS)
 
 # Check for Tkinter/Tix
 if test "x$tkinter" = "x"; then
@@ -628,25 +599,17 @@ fi
 AC_SUBST(PYTHON_GUI_DIR)
 
 # Now check for swig
-if test "x$swigprog" = "x" -a "x$tryswig" = "xyes"; then
-   AC_PATH_PROG(swigprog, swig)
-fi
-if test "x$swigprog" != "x"; then
-   swigver=`$swigprog -version 2>&1 | grep 'SWIG Version' | sed 's/SWIG Version //'`
-   swigmajor=`echo $swigver | sed 's/\.[[0-9]]*\.[[0-9]]*$//'`
-   swigminor=`echo $swigver | sed 's/^[[0-9]]*\.\([[0-9]]*\)\.[[0-9]]*$/\1/'`
-   swigrel=`echo $swigver | sed 's/^[[0-9]]*\.[[0-9]]*\.//'`
-   if test '(' "$swigmajor" -lt 1 ')' -o '(' '(' "$swigmajor" -eq 1 ')' -a '(' "$swigminor" -lt 3 ')' ')' -o '(' '(' "$swigmajor" -eq 1 ')' -a '(' "$swigminor" -eq 3 ')' -a '(' "$swigrel" -lt 21 ')' ')'; then
-      echo "***swig must be version 1.3.21 or greater, disabling swig and perl/python"
-   else
-      echo "swig version $swigver"
+SWIG_DIR=
+SWIG=
+if test "x$tryswig" = "xyes"; then
+   if test "x$swigprog" != "x"; then
+      SWIG="$swigprog"
+   fi
+   AX_PKG_SWIG([1.3.21])
+   if test "x$SWIG" != "x"; then
       AC_DEFINE([HAVE_SWIG], [], [Have swig installed])
       SWIG_DIR=swig
-      SWIG=$swigprog
    fi
-else
-   SWIG_DIR=
-   SWIG=
 fi
 AC_SUBST(SWIG_DIR)
 AC_SUBST(SWIG)
@@ -788,8 +751,8 @@ AC_SUBST(LATEX)
 AC_SUBST(BIBTEX)
 AC_SUBST(DVIPDF)
 
-OPENIPMI_SWIG_LIBS="${PYTHON_POSIX_LIB} \$(top_builddir)/lib/libOpenIPMI.la \$(top_builddir)/utils/libOpenIPMIutils.la \$(top_builddir)/cmdlang/libOpenIPMIcmdlang.la ${GLIB_SINGLE_LIB} ${TCL_LIB}"
-OPENIPMI_SWIG_SO="${PYTHON_POSIX_SO}:\$(top_builddir)/lib/.libs/libOpenIPMI.so:\$(top_builddir)/utils/.libs/libOpenIPMIutils.so:\$(top_builddir)/cmdlang/.libs/libOpenIPMIcmdlang.so:${GLIB_SINGLE_SO}:${TCL_SO}"
+OPENIPMI_SWIG_LIBS="${PYTHON_POSIX_LIB} \$(top_builddir)/lib/libOpenIPMI.la \$(top_builddir)/utils/libOpenIPMIutils.la \$(top_builddir)/cmdlang/libOpenIPMIcmdlang.la ${GLIB_LIB} ${TCL_LIB}"
+OPENIPMI_SWIG_SO="${PYTHON_POSIX_SO}:\$(top_builddir)/lib/.libs/libOpenIPMI.so:\$(top_builddir)/utils/.libs/libOpenIPMIutils.so:\$(top_builddir)/cmdlang/.libs/libOpenIPMIcmdlang.so:${GLIB_SO}:${TCL_SO}"
 AC_SUBST(OPENIPMI_SWIG_LIBS)
 AC_SUBST(OPENIPMI_SWIG_SO)
 
diff --git a/include/OpenIPMI/selector.h b/include/OpenIPMI/selector.h
index 29c0f18..1e87b61 100644
--- a/include/OpenIPMI/selector.h
+++ b/include/OpenIPMI/selector.h
@@ -95,6 +95,11 @@ int sel_set_fd_handlers(struct selector_s *sel,
    sure to not be called again. */
 void sel_clear_fd_handlers(struct selector_s *sel,
 			   int        fd);
+/* Like above, but can only be called if no handlers are active.
+   If it detects a handler is active, it will assert.  This should
+   only be used at startup to clear the fd handler after an error
+   before any handlers are enabled. */
+void sel_clear_fd_handlers_imm(struct selector_s *sel, int fd);
 
 /* Turn on and off handling for I/O from a file descriptor. */
 #define SEL_FD_HANDLER_ENABLED	0
@@ -121,6 +126,11 @@ int sel_start_timer(sel_timer_t    *timer,
 		    struct timeval *timeout);
 
 int sel_stop_timer(sel_timer_t *timer);
+
+/* Stops the timer and calls the done handler when the stop is
+   complete.  This will return an error if the timer is not
+   running or if another done handler is pending running, and
+   the done handler will not be called. */
 int sel_stop_timer_with_done(sel_timer_t *timer,
 			     sel_timeout_handler_t done_handler,
 			     void *cb_data);
@@ -157,6 +167,15 @@ int sel_select(struct selector_s *sel,
 	       void            *cb_data,
 	       struct timeval  *timeout);
 
+/*
+ * Like the above call, but it will return EINTR if interrupted.
+ */
+int sel_select_intr(struct selector_s *sel,
+		    sel_send_sig_cb send_sig,
+		    long            thread_id,
+		    void            *cb_data,
+		    struct timeval  *timeout);
+
 /* This is the main loop for the program.  If NULL is passed in to
    send_sig, then the signal sender is not used.  If this encounters
    an unrecoverable problem with select(), it will return the errno.
@@ -166,6 +185,9 @@ int sel_select_loop(struct selector_s *sel,
 		    long            thread_id,
 		    void            *cb_data);
 
+/* Wake all threads in all select loops. */
+void sel_wake_all(struct selector_s *sel);
+
 typedef void (*ipmi_sel_add_read_fds_cb)(struct selector_s *sel,
 					 int            *num_fds,
 					 fd_set         *fdset,
diff --git a/lib/ipmi_smi.c b/lib/ipmi_smi.c
index 2094ebf..52408c4 100644
--- a/lib/ipmi_smi.c
+++ b/lib/ipmi_smi.c
@@ -901,7 +901,7 @@ ipmi_dev_data_handler(int            fd,
 		      os_hnd_fd_id_t *id)
 {
     ipmi_con_t       *ipmi = (ipmi_con_t *) cb_data;
-    unsigned char    data[MAX_IPMI_DATA_SIZE];
+    unsigned char    data[IPMI_MAX_MSG_LENGTH];
     ipmi_addr_t      addr;
     struct ipmi_recv recv;
     int              rv;
diff --git a/m4/ax_pkg_swig.m4 b/m4/ax_pkg_swig.m4
new file mode 100644
index 0000000..d836eec
--- /dev/null
+++ b/m4/ax_pkg_swig.m4
@@ -0,0 +1,135 @@
+# ===========================================================================
+#        http://www.gnu.org/software/autoconf-archive/ax_pkg_swig.html
+# ===========================================================================
+#
+# SYNOPSIS
+#
+#   AX_PKG_SWIG([major.minor.micro], [action-if-found], [action-if-not-found])
+#
+# DESCRIPTION
+#
+#   This macro searches for a SWIG installation on your system. If found,
+#   then SWIG is AC_SUBST'd; if not found, then $SWIG is empty.  If SWIG is
+#   found, then SWIG_LIB is set to the SWIG library path, and AC_SUBST'd.
+#
+#   You can use the optional first argument to check if the version of the
+#   available SWIG is greater than or equal to the value of the argument. It
+#   should have the format: N[.N[.N]] (N is a number between 0 and 999. Only
+#   the first N is mandatory.) If the version argument is given (e.g.
+#   1.3.17), AX_PKG_SWIG checks that the swig package is this version number
+#   or higher.
+#
+#   As usual, action-if-found is executed if SWIG is found, otherwise
+#   action-if-not-found is executed.
+#
+#   In configure.in, use as:
+#
+#     AX_PKG_SWIG(1.3.17, [], [ AC_MSG_ERROR([SWIG is required to build..]) ])
+#     AX_SWIG_ENABLE_CXX
+#     AX_SWIG_MULTI_MODULE_SUPPORT
+#     AX_SWIG_PYTHON
+#
+# LICENSE
+#
+#   Copyright (c) 2008 Sebastian Huber <sebastian-huber@web.de>
+#   Copyright (c) 2008 Alan W. Irwin
+#   Copyright (c) 2008 Rafael Laboissiere <rafael@laboissiere.net>
+#   Copyright (c) 2008 Andrew Collier
+#   Copyright (c) 2011 Murray Cumming <murrayc@openismus.com>
+#
+#   This program is free software; you can redistribute it and/or modify it
+#   under the terms of the GNU General Public License as published by the
+#   Free Software Foundation; either version 2 of the License, or (at your
+#   option) any later version.
+#
+#   This program is distributed in the hope that it will be useful, but
+#   WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+#   Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License along
+#   with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+#   As a special exception, the respective Autoconf Macro's copyright owner
+#   gives unlimited permission to copy, distribute and modify the configure
+#   scripts that are the output of Autoconf when processing the Macro. You
+#   need not follow the terms of the GNU General Public License when using
+#   or distributing such scripts, even though portions of the text of the
+#   Macro appear in them. The GNU General Public License (GPL) does govern
+#   all other use of the material that constitutes the Autoconf Macro.
+#
+#   This special exception to the GPL applies to versions of the Autoconf
+#   Macro released by the Autoconf Archive. When you make and distribute a
+#   modified version of the Autoconf Macro, you may extend this special
+#   exception to the GPL to apply to your modified version as well.
+
+#serial 11
+
+AC_DEFUN([AX_PKG_SWIG],[
+        # Ubuntu has swig 2.0 as /usr/bin/swig2.0
+        AC_PATH_PROGS([SWIG],[swig swig2.0])
+        if test -z "$SWIG" ; then
+                m4_ifval([$3],[$3],[:])
+        elif test -n "$1" ; then
+                AC_MSG_CHECKING([SWIG version])
+                [swig_version=`$SWIG -version 2>&1 | grep 'SWIG Version' | sed 's/.*\([0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*\).*/\1/g'`]
+                AC_MSG_RESULT([$swig_version])
+                if test -n "$swig_version" ; then
+                        # Calculate the required version number components
+                        [required=$1]
+                        [required_major=`echo $required | sed 's/[^0-9].*//'`]
+                        if test -z "$required_major" ; then
+                                [required_major=0]
+                        fi
+                        [required=`echo $required | sed 's/[0-9]*[^0-9]//'`]
+                        [required_minor=`echo $required | sed 's/[^0-9].*//'`]
+                        if test -z "$required_minor" ; then
+                                [required_minor=0]
+                        fi
+                        [required=`echo $required | sed 's/[0-9]*[^0-9]//'`]
+                        [required_patch=`echo $required | sed 's/[^0-9].*//'`]
+                        if test -z "$required_patch" ; then
+                                [required_patch=0]
+                        fi
+                        # Calculate the available version number components
+                        [available=$swig_version]
+                        [available_major=`echo $available | sed 's/[^0-9].*//'`]
+                        if test -z "$available_major" ; then
+                                [available_major=0]
+                        fi
+                        [available=`echo $available | sed 's/[0-9]*[^0-9]//'`]
+                        [available_minor=`echo $available | sed 's/[^0-9].*//'`]
+                        if test -z "$available_minor" ; then
+                                [available_minor=0]
+                        fi
+                        [available=`echo $available | sed 's/[0-9]*[^0-9]//'`]
+                        [available_patch=`echo $available | sed 's/[^0-9].*//'`]
+                        if test -z "$available_patch" ; then
+                                [available_patch=0]
+                        fi
+                        # Convert the version tuple into a single number for easier comparison.
+                        # Using base 100 should be safe since SWIG internally uses BCD values
+                        # to encode its version number.
+                        required_swig_vernum=`expr $required_major \* 10000 \
+                            \+ $required_minor \* 100 \+ $required_patch`
+                        available_swig_vernum=`expr $available_major \* 10000 \
+                            \+ $available_minor \* 100 \+ $available_patch`
+
+                        if test $available_swig_vernum -lt $required_swig_vernum; then
+                                AC_MSG_WARN([SWIG version >= $1 is required.  You have $swig_version.])
+                                SWIG=''
+                                m4_ifval([$3],[$3],[])
+                        else
+                                AC_MSG_CHECKING([for SWIG library])
+                                SWIG_LIB=`$SWIG -swiglib`
+                                AC_MSG_RESULT([$SWIG_LIB])
+                                m4_ifval([$2],[$2],[])
+                        fi
+                else
+                        AC_MSG_WARN([cannot determine SWIG version])
+                        SWIG=''
+                        m4_ifval([$3],[$3],[])
+                fi
+        fi
+        AC_SUBST([SWIG_LIB])
+])
diff --git a/m4/ax_prog_python_version.m4 b/m4/ax_prog_python_version.m4
new file mode 100644
index 0000000..628a3e4
--- /dev/null
+++ b/m4/ax_prog_python_version.m4
@@ -0,0 +1,66 @@
+# ===========================================================================
+#  http://www.gnu.org/software/autoconf-archive/ax_prog_python_version.html
+# ===========================================================================
+#
+# SYNOPSIS
+#
+#   AX_PROG_PYTHON_VERSION([VERSION],[ACTION-IF-TRUE],[ACTION-IF-FALSE])
+#
+# DESCRIPTION
+#
+#   Makes sure that python supports the version indicated. If true the shell
+#   commands in ACTION-IF-TRUE are executed. If not the shell commands in
+#   ACTION-IF-FALSE are run. Note if $PYTHON is not set (for example by
+#   running AC_CHECK_PROG or AC_PATH_PROG) the macro will fail.
+#
+#   Example:
+#
+#     AC_PATH_PROG([PYTHON],[python])
+#     AX_PROG_PYTHON_VERSION([2.4.4],[ ... ],[ ... ])
+#
+#   This will check to make sure that the python you have supports at least
+#   version 2.4.4.
+#
+#   NOTE: This macro uses the $PYTHON variable to perform the check.
+#   AX_WITH_PYTHON can be used to set that variable prior to running this
+#   macro. The $PYTHON_VERSION variable will be valorized with the detected
+#   version.
+#
+# LICENSE
+#
+#   Copyright (c) 2009 Francesco Salvestrini <salvestrini@users.sourceforge.net>
+#
+#   Copying and distribution of this file, with or without modification, are
+#   permitted in any medium without royalty provided the copyright notice
+#   and this notice are preserved. This file is offered as-is, without any
+#   warranty.
+
+#serial 11
+
+AC_DEFUN([AX_PROG_PYTHON_VERSION],[
+    AC_REQUIRE([AC_PROG_SED])
+    AC_REQUIRE([AC_PROG_GREP])
+
+    AS_IF([test -n "$PYTHON"],[
+        ax_python_version="$1"
+
+        AC_MSG_CHECKING([for python version])
+        changequote(<<,>>)
+        python_version=`$PYTHON -V 2>&1 | $GREP "^Python " | $SED -e 's/^.* \([0-9]*\.[0-9]*\.[0-9]*\)/\1/'`
+        changequote([,])
+        AC_MSG_RESULT($python_version)
+
+	AC_SUBST([PYTHON_VERSION],[$python_version])
+
+        AX_COMPARE_VERSION([$ax_python_version],[le],[$python_version],[
+	    :
+            $2
+        ],[
+	    :
+            $3
+        ])
+    ],[
+        AC_MSG_WARN([could not find the python interpreter])
+        $3
+    ])
+])
